package cn.com.qmth.examcloud.core.oe.admin.api.controller;

import cn.com.qmth.examcloud.core.oe.admin.api.bean.ExamRecordDataBeanConvert;
import cn.com.qmth.examcloud.core.oe.admin.api.bean.ExamRecordDataDomain;
import cn.com.qmth.examcloud.core.oe.common.entity.ExamRecordDataEntity;
import cn.com.qmth.examcloud.core.oe.common.repository.ExamRecordDataRepo;
import cn.com.qmth.examcloud.web.helpers.GlobalHelper;
import io.swagger.annotations.Api;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import java.util.ArrayList;
import java.util.List;


@RestController
@Api(tags = "考试记录相关接口")
@RequestMapping("${$rmp.ctr.oe}/exam/record/data")
public class ExamRecordDataController {

    @Autowired
    private ExamRecordDataRepo examRecordDataRepo;

    @GetMapping("/findExamRecordDataEntity")
    public ExamRecordDataDomain findExamRecordDataEntity(@RequestParam Long examRecordDataId) {
        ExamRecordDataEntity examRecordDataEntity = GlobalHelper.getEntity(examRecordDataRepo, examRecordDataId, ExamRecordDataEntity.class);
        ExamRecordDataDomain domain = ExamRecordDataBeanConvert.copyFrom(examRecordDataEntity);
        domain.setExamRecord(examRecordDataEntity);
        return domain;
    }

    @GetMapping("/findByExamStudentId")
    public List<ExamRecordDataDomain> findByExamStudentId(@RequestParam Long examStudentId) {
        List<ExamRecordDataEntity> examRecordEntities = examRecordDataRepo.findByExamStudentId(examStudentId);
        List<ExamRecordDataDomain> examRecordDataList = new ArrayList<ExamRecordDataDomain>();
        for (ExamRecordDataEntity examRecordData : examRecordEntities) {
            ExamRecordDataDomain domain = ExamRecordDataBeanConvert.copyFrom(examRecordData);
            domain.setExamRecord(examRecordData);
            examRecordDataList.add(domain);
        }
        return examRecordDataList;
    }
}
